
void bitblt(uchar*image,short px, short py, short sy, short rpx, short rpy, short rsx, short rsy)
{
 	short cmpt=0, yy, nb_long, dif, long_count, only_long=0, img_skip=0, scr_skip=1, img_mod4, py_dif, py_dif_img ;
	uchar *scr, *img_src=image ;
	ulong *old, *_screen, *_img ;
	static uchar *screen[2] = 0 ;

	if(!screen[0]) // si on n'a pas dj affect les ecrans
	{
		screen[0] = (uchar*)gpDraw[0].ptbuffer ;
		screen[1] = (uchar*)gpDraw[1].ptbuffer ;
	}

	// cliping

	if(px<0) // gauche
	{
		if(px < (-rsx)) return ; // si trop a gauche pour que qq chose soit affich, on quitte
		rsx += px ; // on enleve l'erreur a la taille affich
		rpx -= px ; // on ajoute l'erreur au decalage x ds l'image
		px=0 ;
	}

	if(py<0) // haut
	{
		if(py < (-rsy)) return ; // erreur trop importante -> quit
		rsy += py ; // on retire l'erreur de la partie affich
		rpy -= py ; // on ajoute l'erreur au decalage y ds l'image
		py=0 ;
	}

	if(px+rsx>320) // droite
	{
		if(px > 319) return ; // trop a droite, on quite
		rsx = 320 - px ; // la partie affiche sera de pos_x jusqu'au bord droit de l'ecran
	}

	if(py+rsy>240) // bas
	{
		if(py > 239) return ; // trop bas pour voir qq chose, quit
		rsy = 240 - py ; // on affichera de la pos_y jusq'au bas de l'ecran
	}

	// on deplace les pointeur d'ecran et d'image pour la copie
	scr = screen[nflip] + (px*240) + 240 - (py+rsy) ;
	img_src += (rpx*sy) + sy-(rpy+rsy) ;

	py_dif = (240-(py+rsy))%4 ;
	py_dif_img = (sy-(rpy+rsy))%4 ;

	if(py_dif_img!=py_dif)	// si l'ecran et l'image n'on pas le mm decalage, on affiche tout par des char
	{
		short cpt ;
		uchar *old_screen = scr ;
		uchar * old_img = img_src ;

		while(rsx--)
		{
			//scr-- ;
			for(cpt=0;cpt<rsy;cpt++)	*(scr++) = *(img_src++) ;
			old_screen = scr = old_screen+240 ;
			old_img = img_src =  old_img + sy ;
		} ;

		return ;
	}
	else	if(py_dif) // sinon, si decalage d'ecran et d'image, on aligne pour ensuite copier par long
		{
			short cpt, cpty ;
			uchar * old = img_src ;
			uchar *old_img = img_src ;
			uchar *old_screen = scr ;
			short size = rsy ;

			while(size--)
			{
				//scr-- ;
				for(cpt=0;cpt<py-dif;cpt++)	*(scr++) = *(img_src++) ;
				old_screen = scr = old_screen+240 ;
				old_img = img_src =  old_img + sy ;
			} ;

			if(!(rsy-=py_dif)) return ;
			scr = screen[nflip] + (px*240) + 240 - (py+rsy) ;
			img_src = old+py_dif ;
		}

	nb_long = rsy>>2 ; // calcul du nb de long a copier par colone (8 bit)
	dif = rsy%4 ; // nb d'octets restant a copier apres la copie par long (0-3)
	if(!dif) only_long=1 ; // si aucun octet restant, on affichera que des long

	if(rpy||(sy!=rsy)) // si l'on doit se deplacer ds l'image apres la copie de la colone, on calcule la valeur de saut
	{
		img_skip = rpy + (sy-(rpy+rsy)) ; // nb d'octet a sauter
		img_mod4 = img_skip%4 ; // on peut deplacer direct le long* ? si ui == 0
		if(!img_mod4) img_skip>>=2 ;
		if(rsy==240) scr_skip=0 ; // on aura a sauter ds l'image mais pas ds l'ecran
	}
	else	// si aucun deplacement necessaire apres la copie
	{	if(only_long) // si que des long a afficher
		{	if(sy==240) // si la hauteur de l'image == 240
			{
				// on affichera tout en 1 seule passe
				nb_long *= rsx ;
				rsx=1 ;
				scr_skip=0 ;
			}
		}
	}

	/*if(key_pressed&16)
	{
		char teub[300] ;
		sprintf(teub,"px %i py %i rpx %i rpy %i\nsy %i rsx %i rsy %i\ndif %i long %i %i\ndec : scr %i img %i\nskip : scr %i img %i %i",px,py,rpx,rpy,sy,rsx,rsy,dif,nb_long,only_long,scr - (screen[nflip]),img_src - image,scr_skip*60,img_skip,img_mod4) ;
		MsgBox(teub) ;
		nflip=0 ;
	}*/

	_screen = (ulong*)scr ;
	_img = (ulong*)img_src ;

	 while(rsx--) // pour chaque colone a afficher
	 {
		old = _screen ;
		long_count=nb_long ;

		if(!only_long) // si qq chose a afficher apres la copie par long
		{
			short cpt ;
			uchar *img = (uchar*)_img ;	// pointeur de char sur l'image
			scr = (uchar*)_screen ;		// pointeur de char sur l'ecran

			for(cpt=0;cpt<dif;cpt++) {	*(scr++) = *(img++) ; } ; // on copie les 'dif' octets

			_screen = (ulong*)scr ;		// on actualise le pointeur d'ecran
			_img = (ulong*)img ;		// et celui d'image
		}

		while(long_count--) *(_screen++) = *(_img++) ; // affichage par long

		if(img_skip) // si on doit se deplacer ds l'image apres la copie de la colone
		{
			if(img_mod4)	_img = (ulong*)(((uchar*)_img) + img_skip) ;
			else		_img += img_skip ;
		}

		if(scr_skip) _screen = old+60 ; // on deplace le pointeur d'ecran d'une colone (60*4=240 pixels) par raport a l'ancien
	} ;
}
