/* this file is a part of Gdl 0.4f and was writen by rov, http://procvor.free.fr */

void load_font(struct font * font, unsigned char * img_font, unsigned char sx, unsigned char sy, unsigned short tr_color, unsigned char nb_char)
{
	unsigned short cpt ;

	font->size_x = sx ;
	font->size_y = sy ;
	font->transp_color = tr_color ;

	for(cpt=0;cpt<nb_char;cpt++)
	{
		font->img[cpt+32] = img_font + (cpt*sx*sy*(bbp>>3)) ;
	} ;
}

void load_font_(struct font * font, unsigned char * img_font, unsigned char sx, unsigned char sy, unsigned short tr_color, unsigned char nb_char, unsigned char start)
{
	unsigned short cpt ;

	font->size_x = sx ;
	font->size_y = sy ;
	font->transp_color = tr_color ;

	for(cpt=0;cpt<nb_char;cpt++)
	{
		font->img[cpt+start] = img_font + (cpt*sx*sy*(bbp>>3)) ;
	} ;
}

// affiche du txt a une certaine position de l'ecran
char draw_text(struct font * font,char * text, short x, short y)
{
	unsigned short cpt;
	int cpt_txt ;
	uint nb_char = strlen(text) ;
	short start_x = x ;

	cpt_txt = -1 ;
	for(cpt=0;cpt<nb_char;cpt++)
	{
		cpt_txt++ ;
		if(text[cpt]=='\n') { y+=(font->size_y+2) ; cpt_txt=-1 ; /*if(y>239) return 'y' ;*/}
		else {
			x = start_x + cpt_txt*font->size_x ;
			//if(x>319) return 'x' ;
			if(text[cpt]!=32) if(x>-font->size_x) if(x<320) if(y>-font->size_y) if(y<240) afficher_sprite_cut(x,y,font->size_x,font->size_y,font->img[text[cpt]],0,font->transp_color) ;
		     }
	} ;

	return 'o' ;
}

// affiche du txt, la fin du txt se trouvera a la position specifi (alignement a droite)
char draw_text_rl(struct font * font, char * text, unsigned short x, unsigned short y)
{
	unsigned short cpt;
	short cpt_txt ;
	unsigned char nb_char = strlen(text) ;

	unsigned short start_x = x - font->size_x*nb_char ;

	cpt_txt = -1 ;
	for(cpt=0;cpt<nb_char;cpt++)
	{
		cpt_txt++ ;
		if(text[cpt]=='\n') { y+=font->size_y ; cpt_txt=-1 ; if(y>239) return 'y' ; }
		else {
			x = start_x + cpt_txt*font->size_x ;
			if(x>319) return 'x' ;
			if(text[cpt]!=32)	afficher_sprite_cut(x,y,font->size_x,font->size_y,font->img[text[cpt]],0,font->transp_color) ;
		     }
	} ;

	return 'o' ;
}

void draw_text_center(struct font * font, char * text)
{
	draw_text(font,text,((320 - (strlen(text)*font->size_x))>>1),((240 - (font->size_y))>>1)) ;
}

void draw_text_center_x(struct font * font, char * text, unsigned short y)
{
	draw_text(font,text,((320 - (strlen(text)*font->size_x))>>1),y) ;
}

void draw_text_center_x_multiline(struct font * font, char * text, unsigned short y)
{
	short cpt=0, size=0, size_max=0 ;

	// search max line size
	while(text[cpt] != '\0')
	{
		if((text[cpt] == '\n')||(text[cpt+1] == '\0'))
		{
			size++ ;
			if(size_max < size) size_max=size ;
			size = 0 ;
		} else size++ ;

		cpt++ ;
	} ;

	draw_text(font,text,(320 - size_max*font->size_x)>>1,y) ;
}

void draw_text_center_y(struct font * font, char * text, unsigned short x)
{
	draw_text(font,text,x,((240 - (font->size_y))>>1)) ;
}

void draw_text_vibrate(struct font * font,char * text, unsigned short x, unsigned short y, unsigned char powa)
{
	draw_text(font,text,x+(powa*((rand()%2)-1)),y+(powa*((rand()%2)-1))) ;
}

void draw_text_center_vibrate(struct font * font,char * text, unsigned char powa)
{
	draw_text(font,text,((320 - (strlen(text)*font->size_x))>>1)+(powa*((rand()%2)-1)),((240 - (font->size_y))>>1)+(powa*((rand()%2)-1))) ;
}

void draw_text_center_x_vibrate(struct font * font,char * text, unsigned short y, unsigned char powa)
{
	draw_text(font,text,((320 - (strlen(text)*font->size_x))>>1)+(powa*((rand()%2)-1)),y+(powa*((rand()%2)-1))) ;
}

void draw_text_center_y_vibrate(struct font * font,char * text, unsigned short x, unsigned char powa)
{
	draw_text(font,text,x+(powa*((rand()%2)-1)),((240 - (font->size_y))>>1)+(powa*((rand()%2)-1))) ;
}

void draw_int(struct font * font, int value, unsigned short x, unsigned short y)
{
 	char buffer[6];
 	sprintf(buffer,"%i",value) ;

	draw_text(font,buffer, x, y) ;
}

void draw_int_rl(struct font * font, int value, unsigned short x, unsigned short y)
{
 	char buffer[6];
 	sprintf(buffer,"%i",value) ;

	draw_text_rl(font,buffer, x, y) ;
}

void draw_vertical_text(struct font * font, char * text, unsigned short x, unsigned short y)
{
	unsigned short cpt;
	short cpt_txt ;
	unsigned short nb_char = strlen(text) ;

	cpt_txt = -1 ;
	for(cpt=0;cpt<nb_char;cpt++)
	{
		cpt_txt++ ;
		if(text[cpt]=='\n') { x+=font->size_x ; cpt_txt=-1 ; }
		else	afficher_sprite_cut(x,y + cpt_txt*font->size_y,font->size_x,font->size_y,font->img[text[cpt]],0,font->transp_color) ;
	} ;
}

